(in-package :cm)

;;;
;;; Note: this clines form causes the NeXT mididriver C code to be source 
;;; included into this file.  the next-midi.c file is actually a LINK to
;;; either next-2-0-midi.c or next-3-0-midi.c, depending on what was
;;; specified in build/build.lisp. the build script will automatially
;;; remove the link file once this file is compiled.
;;; 

(clines "
#define GCL
#include \"next-midi.c\"
")

(defun midi-hook (event time)
 (declare (special *midi-read-hook*)
          (optimize (speed 3) (safety 0)))
 (when *midi-read-hook*
   (funcall (the function *midi-read-hook*)
            (the fixnum event) (the fixnum time))))

(defcfun "MIDI_INPUT_HOOK (msg,tim) int msg,tim;" 0
  ((midi-hook (int msg) (int tim))))

(defentry %%midi-open (int) (int midiopen))
(defentry %midi-close () (int midiclose))
(defentry %midi-start-time () (int midistarttimer))
(defentry %midi-stop-time () (int midistoptimer))
;(defentry %midi-get-time (object) (int midigettime))
(defentry %midi-get-time () (int midigettime1))
(defentry %midi-set-time (int) (int midisettime))
(defentry %midi-set-quanta-size (int) (int midisetquantasize))
(defentry %midi-read-messages () (int midireadmessages))
(defentry %midi-write-message (int int) (int midiwritemessage))
(defentry %midi-flush-transmit () (int midiflushxmit))
(defentry %midi-flush-receive () (int midiflushrecv))
(defentry %midi-hush () (int midihush))
(defentry %midi-all-notes-off (int) (int midiallnotesoff))

